package gui;

/*
 * ServerGui.java
 *
 * Created on 2 de Dezembro de 2001, 01:29
 */

import javax.swing.table.*;
import javax.swing.*;
import java.util.*;
import br.shmem.server.*;
import java.io.*;

/**
 *
 * @author  crolmos & tminc
 */
public class ServerGui extends javax.swing.JFrame {
    
    /** Creates new form ServerGui */
    public ServerGui() {
        super("Distributed Shared Memory Server");
        initComponents();
        clients.setModel(new ClientsModel());
        objects.setModel(new ObjectsModel());
        try {
            PipedOutputStream posOutput = new PipedOutputStream();
            PipedInputStream pisOutput = new PipedInputStream(posOutput);
            System.setOut(new PrintStream(posOutput));
            new Thread(new OutputListener(pisOutput)).start();
        }
        catch(IOException e) {
            System.err.println(e.toString());
            System.exit(-1);
        }
        try {
            PipedOutputStream posError = new PipedOutputStream();
            PipedInputStream pisError = new PipedInputStream(posError);
            System.setErr(new PrintStream(posError));
            new Thread(new ErrorListener(pisError)).start();
        }
        catch(IOException e) {
            System.err.println(e.toString());
            System.exit(-1);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        url = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        plainSocket = new javax.swing.JLabel();
        signedSocket = new javax.swing.JLabel();
        connect = new javax.swing.JButton();
        jPanel7 = new javax.swing.JPanel();
        jSplitPane2 = new javax.swing.JSplitPane();
        jPanel8 = new javax.swing.JPanel();
        requery = new javax.swing.JButton();
        jSplitPane = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        clients = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        objects = new javax.swing.JTable();
        jPanel9 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        errors = new javax.swing.JTextArea();
        jScrollPane4 = new javax.swing.JScrollPane();
        output = new javax.swing.JTextArea();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        panel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        jLabel1.setText("URL:");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        panel.add(jLabel1, gridBagConstraints2);
        
        jLabel2.setText("Plain Socket:");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        panel.add(jLabel2, gridBagConstraints2);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 3;
        gridBagConstraints2.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        panel.add(url, gridBagConstraints2);
        
        jLabel4.setText("Signed Socket:");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 2;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
        panel.add(jLabel4, gridBagConstraints2);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints2.weightx = 1.0;
        panel.add(plainSocket, gridBagConstraints2);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 3;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints2.weightx = 1.0;
        panel.add(signedSocket, gridBagConstraints2);
        
        connect.setText("Connect");
        connect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connectActionPerformed(evt);
            }
        });
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 4;
        gridBagConstraints2.gridy = 1;
        panel.add(connect, gridBagConstraints2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.weightx = 1.0;
        getContentPane().add(panel, gridBagConstraints1);
        
        jPanel7.setLayout(new java.awt.GridLayout(1, 0));
        
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane2.setResizeWeight(0.5);
        jPanel8.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        requery.setText("Requery");
        requery.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                requeryActionPerformed(evt);
            }
        });
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.gridy = 1;
        gridBagConstraints3.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
        jPanel8.add(requery, gridBagConstraints3);
        
        jSplitPane.setResizeWeight(0.5);
        jScrollPane1.setBorder(new javax.swing.border.TitledBorder("Clients"));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(300, 200));
        jScrollPane1.setViewportView(clients);
        
        jSplitPane.setLeftComponent(jScrollPane1);
        
        jScrollPane2.setBorder(new javax.swing.border.TitledBorder("Objects"));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(300, 200));
        jScrollPane2.setViewportView(objects);
        
        jSplitPane.setRightComponent(jScrollPane2);
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.gridy = 0;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.weightx = 1.0;
        gridBagConstraints3.weighty = 1.0;
        jPanel8.add(jSplitPane, gridBagConstraints3);
        
        jSplitPane2.setLeftComponent(jPanel8);
        
        jPanel9.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints4;
        
        jScrollPane3.setBorder(new javax.swing.border.TitledBorder("Errors"));
        errors.setEditable(false);
        jScrollPane3.setViewportView(errors);
        
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints4.weightx = 1.0;
        gridBagConstraints4.weighty = 1.0;
        jPanel9.add(jScrollPane3, gridBagConstraints4);
        
        jScrollPane4.setBorder(new javax.swing.border.TitledBorder("Output"));
        output.setEditable(false);
        jScrollPane4.setViewportView(output);
        
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints4.weightx = 1.0;
        gridBagConstraints4.weighty = 1.0;
        jPanel9.add(jScrollPane4, gridBagConstraints4);
        
        jSplitPane2.setRightComponent(jPanel9);
        
        jPanel7.add(jSplitPane2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        getContentPane().add(jPanel7, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents
    
    private void connectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connectActionPerformed
        // Add your handling code here:
        connect();
    }//GEN-LAST:event_connectActionPerformed
    
    private void requeryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_requeryActionPerformed
        // Add your handling code here:
        requery();
    }//GEN-LAST:event_requeryActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    public void connect() {
        try {
            String url = null;
            int plainPort = -1;
            int signedPort = -1;
            FileInputStream inStream = new FileInputStream("server.ini");
            Properties prop = new Properties();
            prop.load(inStream);
            url = prop.getProperty("url");
            if(url == null) {
                System.err.println("Undefined url.");
                System.exit(-1);
            }
            try {
                plainPort = Integer.parseInt(prop.getProperty("plain_port"));
            }
            catch(NumberFormatException e) {
                System.err.println("Undefined plain_port.");
                System.exit(-1);
            }
            try {
                signedPort = Integer.parseInt(prop.getProperty("signed_port"));
            }
            catch(NumberFormatException e) {
                System.err.println("Undefined signed_port.");
                System.exit(-1);
            }
            
            this.url.setText(url);
            this.plainSocket.setText(Integer.toString(plainPort));
            this.signedSocket.setText(Integer.toString(signedPort));
            
            server = new Server(url, plainPort, signedPort);
            server.setDebugging(true);
        }
        catch(Exception e) {
            System.err.println(e);
            e.printStackTrace(System.err);
            return;
        }
        clients.setModel(new ClientsModel(server.getClients()));
        objects.setModel(new ObjectsModel(server.getObjects()));
    }
    
    public void requery() {
        ((ClientsModel)clients.getModel()).setClients(server.getClients());
        ((ObjectsModel)objects.getModel()).setObjects(server.getObjects());
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new ServerGui().show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel panel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel url;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel plainSocket;
    private javax.swing.JLabel signedSocket;
    private javax.swing.JButton connect;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JButton requery;
    private javax.swing.JSplitPane jSplitPane;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable clients;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable objects;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea errors;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTextArea output;
    // End of variables declaration//GEN-END:variables
    
    private Server server;
    
    class ObjectsModel extends AbstractTableModel {
        private final String columns[] = {
            "Owner",
            "Global Name",
            "Time Stamp",
            "Writer",
            "Lockable"
        };
        
        private List objects;
        
        public ObjectsModel() {
            objects = new ArrayList();
        }
        
        public ObjectsModel(List objects) {
            this.objects = objects;
        }
        
        public void setObjects(List objects) {
            this.objects = objects;
            fireTableDataChanged();
        }
        
        public int getRowCount() {
            return objects.size();
        }
        
        public int getColumnCount() {
            return 5;
        }
        
        public java.lang.Object getValueAt(int row, int column) {
            ObjectInfo info = (ObjectInfo) objects.get(row);
            
            switch(column) {
                case 0 : return info.getOwner();
                case 1 : return info.getGlobalName();
                case 2 : return info.getTimeStamp();
                case 3 : return info.getWriter();
                case 4 : return new Boolean(info.isLockable());
                default : return null;
            }
        }
        
        public String getColumnName(int column) {
            return columns[column];
        }
    }
    
    class ClientsModel extends AbstractTableModel {
        private final String columns[] = {
            "Owner"
        };
        
        private List clients;
        
        public ClientsModel() {
            clients = new ArrayList();
        }
        
        public ClientsModel(List clients) {
            this.clients = clients;
        }
        
        public void setClients(List clients) {
            this.clients = clients;
            fireTableDataChanged();
        }
        
        public int getRowCount() {
            return clients.size();
        }
        
        public int getColumnCount() {
            return 1;
        }
        
        public java.lang.Object getValueAt(int row, int column) {
            switch(column) {
                case 0 : return clients.get(row);
                default : return null;
            }
        }
        
        public String getColumnName(int column) {
            return columns[column];
        }
    }
    
    class ErrorListener implements Runnable {
        
        BufferedReader in;
        
        public ErrorListener(InputStream in) {
            this.in = new BufferedReader(new InputStreamReader(in));
            
        }
        
        public void run() {
            for(;;) {
                try {
                    if(in.ready())
                        errors.append(in.readLine() + "\n");
                }
                catch(IOException e) {
                }
            }
        }
        
    }
    
    class OutputListener implements Runnable {
        
        BufferedReader in;
        
        public OutputListener(InputStream in) {
            this.in = new BufferedReader(new InputStreamReader(in));
            
        }
        
        public void run() {
            for(;;) {
                try {
                    if(in.ready())
                        output.append(in.readLine() + "\n");
                }
                catch(IOException e) {
                }
            }
        }
        
    }
}
